<?
/*

                                   _JNJ`
                               .JNMH`
                              JMMF`       `;.
                            .NMM)          `MN.
                            MMM)            (MML
                           (MMM`             MMML
                     M  I  D  N  I  G  H  T    C  o  D  E
                           (NMMF             MHNH
                            NMML            .MMM
                             NMML          .NMH
                              4MMNL       .#F
                               `4HNNL_   `
                                   `"""`

                          Copyright (C) 2004-2007
       "Ian (Larry) Latter" <ian dot latter at midnightcode dot org>

    Midnight Code is a registered trademark of Ian Latter.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, and mirrored at the Midnight Code web
    site; as at version 2 of the License only.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
    General Public License for more details.

    You should have received a copy of the GNU General Public License
    (version 2) along with this program; if not, write to the Free
    Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
    02111-1307 USA, or see http://midnightcode.org/gplv2.txt


  -----------------------------------------------------------------------

  Welcome,

  This is a PHP script that can be used to provide routine alerts to a
  CubeCart administrator in the event that stock quantities should fall
  below a preset value.  This particular script is a variation of the
  original "stock_level_alert" script.  It is designed to work for sites
  that have purchased and installed Estelle's "Product Options" mod.

  This script is designed to be an administrative function, and must be
  installed under the "admin" directory of the CubeCart installation.
  The recommended installation directory is;
    admin/stock_level_prodopts_alert/

  Once the script has been copied into this directory, you can run this
  new "action" at any time, by visiting the administration page at;
    http://www.domain.com/admin/stock_level_prodopts_alert/
    stock_level_prodopts_alert.php

  Just below these comments are some variables that can be tuned for
  your personal tastes and preferences.  Set the "quantity_low_water"
  value to the level at which stock levels should raise an alarm.

  The "quantity_hidden" value is designed to allow the CubeCart
  administrator to set a stock quantity for those options which are
  invalid (not stocked), that will allow them to be removed from the
  report and excluded from alerts.

  Change the "email_subject" value to something appropriate to your
  message style, and alter the "email_from" value to a valid sender
  email address (something which will hopefully capture bounces to the
  CubeCart administration email address).

  If you prefer to receive HTML formatted email, then set "email_html"
  to 1.


  -----------------------------------------------------------------------

*/

  // Each product's quantity is tested against this value
  $quantity_low_water = 2;
  $quantity_hidden    = 10000;

  // Various adjustable email options
  $email_subject      = "[CubeCart] Low Stock Alert";
  $email_from         = "postmaster@domain.com";
  $email_body         = "The following products have fallen below the" .
                        " elected low water mark (" . $quantity_low_water .
                        " units or less).\n\n";
  $email_html         = 0;


  // --------------------------------------------------------------------



  include("../../includes/ini.inc.php");
  include("../../includes/global.inc.php");
  require_once("../../classes/db.inc.php");
  $db = new db();
  include_once("../../includes/functions.inc.php");
  $config = fetchDbConfig("config");
  include_once("../../language/".$config['defaultLang']."/lang.inc.php");
  $enableSSl = 1;
  include_once("../../includes/sslSwitch.inc.php");
  include("../includes/auth.inc.php");
  include("../includes/functions.inc.php");
  include("../../classes/htmlMimeMail.php");

  $catdb = new db();
  $prddb = new db();

  if(permission("settings","read")==FALSE){
    header("Location: ".$GLOBALS['rootRel']."admin/401.php");
    exit;
  }

  include("../includes/header.inc.php");

  $email_flag = 0;
  if($email_html == 1) {
    $email_body = nl2br(htmlspecialchars($email_body)) . "<pre>\n";
  }


  function stock_level_assessor($product_code, $category_name, $product_name,
                                $product_quantity, $product_price) {
    global $quantity_low_water, $email_body, $email_flag;

    if($product_quantity <= $quantity_low_water) {
      $email_flag     = 1;
      $more_body      = "    " . $product_quantity . " unit";
      if($product_quantity != 1) {
        $more_body   .= "s";
      }
      $more_body     .= " of " . $product_name . " / " . $category_name;
      $more_body     .= " (" . $product_code . ")\n";
      if($email_html == 1) {
        $more_body    = nl2br(htmlspecialchars($more_body));
      }
      $email_body    .= $more_body;
    }

?>
<tr>
  <td align="left" width="25"> &nbsp; </td>
  <td align="left"><? echo htmlspecialchars($product_code); ?></td>
  <td align="left" width="400"><? echo htmlspecialchars($product_name); ?></td>
  <td align="left"><? echo htmlspecialchars(priceFormat($product_price)); ?></td>
  <td align="left"> &nbsp;<?
    if($product_quantity <= $quantity_low_water) {
?><font color="red"><b><?
    }
  echo htmlspecialchars($product_quantity);
    if($product_quantity <= $quantity_low_water) {
?></b></font><?
    }
  ?></td>
</tr>
<?

    return 1;
  }

?>
<table border="0" width="550">
<?

  $categories = $catdb->select("SELECT cat_name, cat_id FROM ".
                $glob['dbprefix']."CubeCart_category WHERE ".
                "cat_father_id = 0 ORDER BY cat_name ASC");

  foreach($categories as $category) {

    $category_id   = $category["cat_id"];
    $category_name = $category["cat_name"];

?>
<tr>
  <td colspan="5" align="left"><? echo htmlspecialchars($category_name); ?></td>
</tr>
<?

    $products = $prddb->select("SELECT ".
                $glob['dbprefix']."CubeCart_cats_idx.cat_id, ".
                $glob['dbprefix']."CubeCart_cats_idx.productId, ".
                "productCode, quantity, description, image, price, name, ".
                "popularity, sale_price, stock_level, useStockLevel FROM ".
                $glob['dbprefix']."CubeCart_cats_idx INNER JOIN ".
                $glob['dbprefix']."CubeCart_inventory ON ".
                $glob['dbprefix']."CubeCart_cats_idx.productId = ".
                $glob['dbprefix']."CubeCart_inventory.productId WHERE ".
                $glob['dbprefix']."CubeCart_cats_idx.cat_id = ".
                $category_id . " ORDER BY price DESC");

    foreach($products as $product) {

      $product_id       = $product["productId"];
      $product_code     = $product["productCode"];
      $product_name     = $product["name"];
      $product_price    = $product["price"];
      $product_quantity = $product["stock_level"];

      $levelmods = $prddb->select("SELECT ".
                   "stock_level, useStockLevel, productCode FROM ".
                   $glob['dbprefix']."CubeCart_inventory ".
                   "WHERE productId = " . $product_id);

      foreach($levelmods as $levelmod) {
        $levelmod_use = $levelmod["useStockLevel"];

        if($levelmod_use) {

          $assignments = $prddb->select("SELECT ".
                         "DISTINCT bot.assign_id, value_name FROM ".
                         $glob['dbprefix']."CubeCart_options_mid AS mid, ".
                         $glob['dbprefix']."CubeCart_options_bot AS bot ".
                         "WHERE mid.value_id = bot.value_id AND ".
                         "bot.product = " . $product_id . " " .
                         "ORDER BY bot.assign_id ASC");

          foreach($assignments as $assignment) {

            $assignment_id   = $assignment["assign_id"];
            $assignment_name = $assignment["value_name"];

            $optionlevels = $prddb->select("SELECT * FROM ".
                            $glob['dbprefix']."CubeCart_options_stock_levels " .
                            "WHERE assign_key = " . $assignment_id . " " .
                            "AND product_id = " . $product_id);

            if(!is_array($optionlevels))
              continue;

            foreach($optionlevels as $optionlevel) {

              $optionlevel_quantity = $optionlevel["stock_level"];
              $optionlevel_code     = $optionlevel["product_code"];

              if($optionlevel_quantity == $quantity_hidden)
                continue;

              if(strlen($optionlevel_code)) {
                $check_code     = $product_code . "/" . $optionlevel_code;
              } else {
                $check_code     = $product_code;
              }
              $check_name     = $product_name . " - " . $assignment_name;
              $check_quantity = $optionlevel_quantity;

              stock_level_assessor($check_code, $category_name, $check_name,
                                   $check_quantity, $product_price);
            }
          }
        } else {
          stock_level_assessor($product_code, $category_name, $product_name,
                               $product_quantity, $product_price);
        }
      }
    }
  }

?>
</table>
<?

  if($email_flag == 1) {
    if($email_html == 1) {
      $email_body .= "</pre>\n";
    }

    $email = new htmlMimeMail();
    $email->setText($email_body);
    $email->setReturnPath($email_from);
    $email->setFrom('<'.$email_from.'>');
    $email->setSubject($email_subject);
    $email->setHeader('X-Mailer', 'CubeCart Stock Level Mailer');

    $send = $email->send(array($config['masterEmail']), $config['mailMethod']);
  }


  include("../includes/footer.inc.php");

?>
